//+------------------------------------------------------------------------+
//|                         Copyright 2015, MetaQuotes Software Corp.      |
//|                                             https://www.mql5.com       |
//| Indicator: iClock_Mod1                                                |                                                                  |
//| Author: mladen - https://www.forex-tsd.com                             |
//| Modifier: File45 - https://www.mql5.com/en/users/file45/publications   |
//| * 2015/4/09: Convert from mql5 to mql4                                 |
//| * 2015/4/09: Add alerts and label colored alert states.                |
//+------------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property description "Continuous second by second count down bar timer." 

#property indicator_chart_window

enum PS
{
  a, // PopUp Alert
  b // Sound Alert
};  

///////////////////////////////////////////////////////////////////////////// 
input PS    PopUp_or_Sound   = b;             // Sound or PopUp          
input bool  PushNotification = False;         // Mobile Alert 
input color FontColor        = DarkSlateGray; // Font Color - count down
input color NoBarColor       = Red;           // Font Color - count up
input int   FontSize         = 50;            // Font Size 
input bool  FontBold         = true;          // Font Bold
input int   FontShift        = 12;            // Font Shift
/////////////////////////////////////////////////////////////////////////////

datetime LastAlertTime;
string TF;
string theFont;
string clockName="CandleTimer";

int AS = 0;
bool switchz = false;
string ASText;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int  OnInit()
  {
   switch(FontBold)
     {
      case 0: theFont = "Arial"; break;
      case 1: theFont = "Arial Bold"; break;
     }
  
  int Minx = Period();
   string Miny = "M";
   string Minz = IntegerToString(Period());
   
   
   if(Period() < 60)
   {
     TF = StringConcatenate(Miny, Minz);
   }
   else if(Period() == 60)
   {
     TF = "H1";
   }
   else if(Period()== 240)
   {
     TF = "H4";
   }  
   else if(Period() == 1440)
   {
     TF = "D1";
   }
   else if(Period() == 10080)
   {
     TF = "W1";
   }
   else 
   {
     TF = "MN";
   }              
   
   LastAlertTime=TimeCurrent();
// atrHandle = (iATR(NULL,0,30,0)); 
   EventSetTimer(1);
//---
   return(0);
  }
void OnDeinit(const int reason) { EventKillTimer(); ObjectDelete(clockName);}
void OnTimer( )                 { refreshClock();  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int  OnCalculate(const int rates_total,
                 const int prev_calculated,
                 const datetime &time[],
                 const double &open[],
                 const double &high[],
                 const double &low[],
                 const double &close[],
                 const long &tick_volume[],
                 const long &volume[],
                 const int &spread[])
  {
   if((PopUp_or_Sound == a && AS == 1) && (LastAlertTime<Time[0]))
     {
      Alert("New Bar " , " " + Symbol()+ " - " + TF + "\n"+ TimeToStr(TimeCurrent(),TIME_SECONDS)+"  "+TimeToStr(TimeCurrent(),TIME_DATE)+"\n" + AccountServer());
     }
   else if((PopUp_or_Sound == b && AS == 1) && (LastAlertTime<Time[0]))
     {
      PlaySound("Alert.wav");
     }
  if(PushNotification && (LastAlertTime<Time[0]))
  {
     SendNotification("New Bar " + " " + Symbol()+ " - " + TF + "\n"+TimeToStr(TimeCurrent(),TIME_SECONDS)+"  "+TimeToStr(TimeCurrent(),TIME_DATE) + "\n" + AccountServer());  
  }   
   refreshClock();
   LastAlertTime=Time[0];
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void refreshClock()
  {
   static bool inRefresh=false;
   if(inRefresh) return;
   inRefresh=true;
   ShowClock(); ChartRedraw();
   inRefresh=false;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ShowClock()
  {
   int periodMinutes = periodToMinutes(Period());
   int shift         = periodMinutes*FontShift*60;
   int currentTime   = (int)TimeCurrent();
   int localTime     = (int)TimeLocal();
   int barTime       = (int)iTime();
   int diff          = (int)MathMax(round((currentTime-localTime)/3600.0)*3600,-24*3600);
//---
   color  theColor;
   string time=getTime(barTime+periodMinutes*60-localTime-diff,theColor);
   time=(TerminalInfoInteger(TERMINAL_CONNECTED)) ? time : time+" x";
//---
   if(ObjectFind(0,clockName)<0)
      ObjectCreate(0,clockName,OBJ_TEXT,0,barTime+shift,0);
   /*switch(AlertMode)
   { */  
    ObjectSetString(0,clockName,OBJPROP_TEXT,time+ASText); 
   /* case 1: ObjectSetString(0,clockName,OBJPROP_TEXT,time + " ^"); break;
    case 2: ObjectSetString(0,clockName,OBJPROP_TEXT,time + " ~");
    }*/
   ObjectSetString(0,clockName,OBJPROP_FONT,theFont);
   ObjectSetInteger(0,clockName,OBJPROP_FONTSIZE,FontSize);
   ObjectSetInteger(0,clockName,OBJPROP_COLOR,theColor);
   ObjectSet(clockName, OBJPROP_SELECTABLE, false);
   if(ChartGetInteger(0,CHART_SHIFT,0)==0 && (shift>=0))
      ObjectSetInteger(0,clockName,OBJPROP_TIME,barTime-shift*3);
   else  ObjectSetInteger(0,clockName,OBJPROP_TIME,barTime+shift);
//---
   double price[]; if(CopyClose(Symbol(),0,0,1,price)<=0) return;
   double atr[];
//if (CopyBuffer(atrHandle,0,0,1,atr)<=0) return;
   price[0]+=3.0*atr[0]/4.0;
//---
   bool visible=((ChartGetInteger(0,CHART_VISIBLE_BARS,0)-ChartGetInteger(0,CHART_FIRST_VISIBLE_BAR,0))>0);
   if(visible && price[0]>=ChartGetDouble(0,CHART_PRICE_MAX,0))
      ObjectSetDouble(0,clockName,OBJPROP_PRICE,price[0]-1.5*atr[0]);
   else  ObjectSetDouble(0,clockName,OBJPROP_PRICE,price[0]);
   
   if(AS == 1 && PopUp_or_Sound == b && PushNotification == true)
     {
        ASText = "~>";
     }
     else if(AS == 1 && PopUp_or_Sound == b && PushNotification == false)
     {
        ASText = "~";
     }  
     else if(AS == 0 && (PopUp_or_Sound == a || PopUp_or_Sound == b) && PushNotification == false)
     {
         ASText = "";
     }  
      else if(AS == 0 && (PopUp_or_Sound == a || PopUp_or_Sound == b) && PushNotification == true)
     {
         ASText = ">";
     } 
      else if(AS == 1 && PopUp_or_Sound == a && PushNotification == true)
     {
         ASText = "^>";
     }  
      else if(AS == 1 && PopUp_or_Sound == a && PushNotification == false)
     {
         ASText = "^";
     }  
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string getTime(int times,color &theColor)
  {
   string stime="";
   int    seconds;
   int    minutes;
   int    hours;
// if (times < 0) {theColor = ValuesNegativeColor; times = (int)fabs(times);}
// else  theColor = ValuesPositiveColor;
   if(times<0)
     {
      theColor=NoBarColor; times=(int)fabs(times);
     }
   else if(times>0)
     {
      theColor = FontColor;
     }
   seconds = (times%60);
   hours   = (times-times%3600)/3600;
   minutes = (times-seconds)/60-hours*60;
//---
   if(hours>0)
      if(minutes<10)
         stime = stime+(string)hours+":0";
   else  stime = stime+(string)hours+":";
   stime=stime+(string)minutes;
   if(seconds<10)
      stime=stime+":0"+(string)seconds;
   else  stime=stime+":"+(string)seconds;
   return(stime);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
datetime iTime(ENUM_TIMEFRAMES forPeriod=PERIOD_CURRENT)
  {
   datetime times[]; if(CopyTime(Symbol(),forPeriod,0,1,times)<=0) return(TimeLocal());
   return(times[0]);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int periodToMinutes(int period)
  {
   int i;
   static int _per[]={1,2,3,4,5,6,10,12,15,20,30,60,120,180,240,360,480,720,1440,10080,43200,0x4001,0x4002,0x4003,0x4004,0x4006,0x4008,0x400c,0x4018,0x8001,0xc001};
   static int _min[]={1,2,3,4,5,6,10,12,15,20,30,60,120,180,240,360,480,720,1440,10080,43200};
//---
   if(period==PERIOD_CURRENT)
      period=Period();
   for(i=0;i<20;i++) if(period==_per[i]) break;
   return(_min[i]);
  }
//+------------------------------------------------------------------+


void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{

   if(CHARTEVENT_OBJECT_CLICK && sparam==clockName) //  Auto Button clicked
   { 
     switchz=!switchz;
     AS=switchz;
   }
   
   return; 
}